* PACKAGE LSTEDY  !" ϳ(Ф)
*"                  ver 1.02                       93/09/27 takepiro
**********************************************************************
      SUBROUTINE LSTEDY                      !"  ϳ
     M             ( GAU   , GAV   , GAW   , GAT   ,
     M               GATOR , GAPOR , 
     I               MFIX  ,
     C               ALON  , DLON  , ALAT  , DLAT  ,
     C               ARAD  , DRAD                    )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZLDIM)                      !" ѥ᥿, 
      INCLUDE   (ZHDIM)                      !" ʸʸ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zldim.F"                    !" ѥ᥿, 
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY]
      REAL       GAU   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAV   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GAW   ( IDIM, JDIM, 0:KDIM )  !" ľ 
      REAL       GAT   ( IDIM, JDIM, 0:KDIM )  !"    
      REAL       GATOR ( IDIM, JDIM, 0:KDIM )  !" ȥ 
      REAL       GAPOR ( IDIM, JDIM, 0:KDIM )  !" ݥ 
*"       : ʻǡ(t) <DYNMCS>  ʻǡ
*"           -׻, -Ф
*
*   [INPUT]
      INTEGER    MFIX                        !" ȿ
*
      REAL       ALON  ( IDIM )              !" 
      REAL       DLON  ( IDIM )              !" ٲٽ
      REAL       ALAT  ( JDIM )              !" 
      REAL       DLAT  ( JDIM )              !" ٲٽ
      REAL       ARAD  ( 0:KDIM )            !" ٥()
      REAL       DRAD  ( 0:KDIM )            !" ()
*"        : ɸʻ
*
*   [INTERNAL ONCE]
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       RAYL                        !" 쥤꡼
      REAL       TAU                         !" ƥ顼
      REAL       PRND                        !" ץɥ
*
      SAVE       NMO   , FLAPLA, EDEL  ,
     &           UVFACT
*
      LOGICAL    OSETC , OFIRST
      DATA       OSETC , OFIRST  / .FALSE., .TRUE.  /
      SAVE       OSETC , OFIRST
*
      LOGICAL    ONONLN                      !" ϳإå
*
      LOGICAL    OATOR , OAPOR , OAT         !" оʪ
      SAVE       OATOR , OAPOR , OAT
*
*   [INTERNAL WORK]
      REAL       GTUA  ( IDIM, JDIM, 0:KDIM )  !" ưѲգ
      REAL       GTVA  ( IDIM, JDIM, 0:KDIM )  !" ̱ưѲ֣
      REAL       GTWA  ( IDIM, JDIM, 0:KDIM )  !" ľưѲ֣
      REAL       GTH   ( IDIM, JDIM, 0:KDIM )  !" ٻѲ  
*"       : ʻѲ­
*
      REAL       GTUT  ( IDIM, JDIM, 0:KDIM )  !" ή  գ
      REAL       GTVT  ( IDIM, JDIM, 0:KDIM )  !" ̰ή  ֣
      REAL       GTWT  ( IDIM, JDIM, 0:KDIM )  !" ٱľή  ף
*"       : Ѳ
*
      REAL       WTTOR ( NMDIM, 0:KDIM      )  !" ȥ 
      REAL       WTPOR ( NMDIM, 0:KDIM      )  !" ݥ 
      REAL       WTT   ( NMDIM, 0:KDIM      )  !"   
*"       : ڥȥѲ
*
      REAL       COFMTX( MATDMX , MATDMX )   !" 
      REAL       VSTEDY( MATDMX )            !"  / 
*
      INTEGER    NMKMTX ( NMDIM, 0:KDIM, 3 ) !" ź
      INTEGER    NMKMAX                      !" κź
      INTEGER    NMTLST  ( NMDIM )           !" MFIX ʬꥹ(ȥ)
      INTEGER    NMPLST  ( NMDIM )           !" MFIX ʬꥹ(ݥ)
      INTEGER    NMQLST  ( NMDIM )           !" MFIX ʬꥹ()
      INTEGER    NMTMAX                      !" NMTLST κź
      INTEGER    NMPMAX                      !" NMPLST κź
      INTEGER    NMQMAX                      !" NMQLST κź
*
      INTEGER    IERR                        !" ֥롼󥨥顼
      REAL       EPS                         !" ðȽ
      REAL       EPS0                        !" ðȽ
      DATA       EPS0 / 3.52D-15 /
*"       : ͭͷ׻ѹ
*
      INTEGER    IUNIT                       !" ɸֹ
      INTEGER    I , J
*
*"  << 0.SETCON :  >>
*
*   [ONCE]
      IF ( .NOT. OSETC ) THEN
         OSETC = .TRUE.
         CALL    DSETC                 !" ڥȥ
     O         ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C           ALAT  , DLAT                      )
      ENDIF
*
*   [ONCE]
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
         CALL    DPARM                     !" ѥ᥿
     O             ( RAYL   , TAU  , PRND  , 
     O               ONONLN                   )
*
         IF( ONONLN )THEN
            CALL MSGDMP('W','LSTDY',
     &                  'N-LIN. DYNAMICS SWITCH WAS NEGLECTED')
         ENDIF
*
         CALL HSPARM
     I          ( 'RAYLEIGH NUMBER', RAYL   )
         CALL HSPARM
     I          ( 'TAYLOR NUMBER'  , TAU**2 )
         CALL HSPARM
     I          ( 'PRANDTL NUMBER' , PRND   )
*
c$$$         CALL DHSTRG                    !" 
*
         CALL LSTPHS                         !" оʪ̤
     O         ( OATOR  , OAPOR  , OAT  )
      ENDIF
*
*" << 1. η׻ : ϳ >>
*
      CALL CLCSTR( 'LSTMTX' )
*
      CALL MKMLST
     O      ( NMKMTX , NMKMAX ,
     O        NMTLST , NMTMAX , 
     O        NMPLST , NMPMAX , 
     O        NMQLST , NMQMAX , 
     F        OATOR  , OAPOR  , OAT   , 
     I        NMO    , MFIX              )
*
      CALL LSTMTX
     O      ( COFMTX ,
     I        NMKMTX , NMKMAX , 
     I        NMTLST , NMTMAX , 
     I        NMPLST , NMPMAX , 
     I        NMQLST , NMQMAX , 
     I        RAYL   , TAU    , PRND   ,
     F        OATOR  , OAPOR  , OAT    , 
     C        NMO    , FLAPLA , 
     C        ARAD   , DRAD                       )
*
      CALL CLCEND( 'LSTMTX' )
*
*" << 2. η׻ >>
*
      CALL CLCSTR( 'W2VECT' )
*
      CALL GRDDYN               !"  ϳع
     O         ( GTUA  , GTVA  , GTWA  , 
     O           GTUT  , GTVT  , GTWT  , GTH   ,
     I           GAU   , GAV   , GAW   , GAT   ,
     C           UVFACT, FLAPLA, 
     C           ALAT  , DLAT  , ARAD  , DRAD    )
*
      CALL GRDFRC               !" ϳس(ʻ)
     M         ( GTUA  , GTVA  , GTWA  , 
     M           GTUT  , GTVT  , GTWT  , GTH   ,
     C           ALON  , DLON  , ALAT  , DLAT  ,
     C           ARAD  , DRAD                    )
*
      CALL TENG2W               !" Ѳ򥹥ڥȥ
     O         ( WTTOR , WTPOR , WTT   , 
     I           GTUA  , GTVA  , GTWA  , 
     I           GTUT  , GTVT  , GTWT  , GTH , 
     C           FLAPLA,
     C           ARAD  , DRAD                  )
*
      CALL W2VECT               !" ٥ȥ
     O         ( VSTEDY , 
     I           WTTOR  , WTPOR , WTT   , 
     I           NMKMTX , NMKMAX , 
     I           NMTLST , NMTMAX , 
     I           NMPLST , NMPMAX , 
     I           NMQLST , NMQMAX , 
     F           OATOR  , OAPOR  , OAT    )
*
      DO 2000 I = 1, NMKMAX
         VSTEDY( I ) = - VSTEDY( I )
 2000 CONTINUE 
*
      CALL CLCSTR( 'W2VECT' )
*
*" << 3. ׻ >>
*
      CALL CLCSTR( 'LGLU' )
*
      EPS = EPS0 * PRND         !" ðδͤ
*
      CALL LEIGLU               !" ϢΩ 1 
c$$$      CALL LSVDSL               !" ðϢΩ 1 
     M       ( COFMTX ,
     M         VSTEDY ,
     O         IERR   , 
     I         EPS    ,
     I         NMKMAX , .TRUE.   )
*
      IF ( IERR .EQ. 0 )THEN
         CALL LEIVEC
     O       ( GAU    , GAV    , GAW    , GAT    ,
     O         GATOR  , GAPOR  , 
     I         VSTEDY , VSTEDY ,
     I         NMKMTX , 
     I         NMTLST , NMTMAX , 
     I         NMPLST , NMPMAX , 
     I         NMQLST , NMQMAX , 
     F         OATOR  , OAPOR  , OAT    ,
     C         NMO    , FLAPLA , UVFACT , 
     C         ARAD   , DRAD                       )
      ENDIF
      CALL CLCSTR( 'LGLU' )
*
*
*" << OUTPUT :  >>
*
      CALL HISTIN ( GTUA  , 'UA' )  !" ΰ
      CALL HISTIN ( GTVA  , 'VA' )
      CALL HISTIN ( GTWA  , 'WA' )
      CALL HISTIN ( GTUT  , 'UT' )  !" ΰ
      CALL HISTIN ( GTVT  , 'VT' )
      CALL HISTIN ( GTWT  , 'WT' )
      CALL HISTIN ( GTH   , 'H'  )
*
      RETURN
      END
**********************************************************************
      SUBROUTINE  W2VECT               !" ٥ȥ
     O                ( EIGVEC , 
     I                  WDTOR  , WDDPOR , WDT   , 
     I                  NMKMTX , NMKMAX , 
     I                  NMTLST , NMTMAX , 
     I                  NMPLST , NMPMAX , 
     I                  NMQLST , NMQMAX , 
     F                  OATOR  , OAPOR  , OAT    )
*
*   [PARAM]
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻ, ȿ
      INCLUDE   (ZLDIM)                      !" ʻ, ȿ
#else
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zldim.F"                    !" 礭
#endif
*
*"  [OUTPUT]
      REAL       EIGVEC( MATDMX )            !" ͭ٥ȥ
*
*"  [INPUT]
      REAL       WDTOR ( NMDIM , 0:KDIM     )  !" ȥ 
      REAL       WDDPOR( NMDIM , 0:KDIM     )  !" ݥ D_l 
      REAL       WDT   ( NMDIM , 0:KDIM     )  !"   
*
      INTEGER    NMKMTX ( NMDIM, 0:KDIM, 3 ) !" ź
      INTEGER    NMKMAX                      !" κź
      INTEGER    NMTLST  ( NMDIM )           !" MFIX ʬꥹ(ȥ)
      INTEGER    NMPLST  ( NMDIM )           !" MFIX ʬꥹ(ݥ)
      INTEGER    NMQLST  ( NMDIM )           !" MFIX ʬꥹ()
      INTEGER    NMTMAX                      !" NMTLST κź
      INTEGER    NMPMAX                      !" NMPLST κź
      INTEGER    NMQMAX                      !" NMQLST κź
*
      LOGICAL    OATOR , OAPOR , OAT         !" оʪ
*
      INTEGER    K, NML
*
*"     < 1. ͭ٥ȥη׻(ڥȥ) >
*
      IF ( OATOR ) THEN
         DO 1100 K = 1, KDIM-1
            DO 1100 NML = 1, NMTMAX
               EIGVEC( NMKMTX(NML,K,1) ) 
     &               = WDTOR( NMTLST(NML), K ) 
 1100    CONTINUE 
      ENDIF
*
      IF ( OAPOR )THEN
         DO 1200 K = 2, KDIM-2
            DO 1200 NML = 1, NMPMAX
               EIGVEC( NMKMTX(NML,K,2) ) 
     &               = WDDPOR( NMPLST(NML), K ) 
 1200    CONTINUE 
      ENDIF
*
      IF ( OAT ) THEN
         DO 1300 K = 1, KDIM-1
            DO 1300 NML = 1, NMQMAX
               EIGVEC( NMKMTX(NML,K,3) )
     &               = WDT( NMQLST(NML), K ) 
 1300    CONTINUE 
      ENDIF
*
      RETURN
      END
**********************************************************************
      SUBROUTINE LSTPHS                         !" оʪ̤
     O         ( OATOR  , OAPOR  , OAT  )
*
*"  [OUTPUT]
      LOGICAL    OATOR                       !" ȥϥå
      LOGICAL    OAPOR                       !" ݥϥå
      LOGiCAL    OAT                         !" ٲϥå
*
*"  [INTERNAL ONCE]
      LOGICAL    OTOR                        !" ȥϥå
      LOGICAL    OPOR                        !" ݥϥå
      LOGiCAL    OTEMP                       !" ٲϥå
      DATA       OTOR  ,  OPOR  ,  OTEMP 
     &        / .TRUE. , .TRUE. , .TRUE. /
*
      NAMELIST   /NMLPHS/  OTOR , OPOR , OTEMP
*
*   [INTERNAL WORK]
      INTEGER    IFPAR, JFPAR
*
*"     < 1. оʪ̤ >
*
C      WRITE  ( JFPAR, NMLPHS )
      CALL   REWNML ( IFPAR , JFPAR )
      READ   ( IFPAR, NMLPHS , END=1190 )
 1190 WRITE  ( JFPAR, NMLPHS )
*
      OATOR = OTOR
      OAPOR = OPOR
      OAT   = OTEMP
*
      IF ( (.NOT.OATOR ) .OR. (.NOT. OAPOR ) .OR. (.NOT. OAT ) )THEN
         CALL MSGDMP( 'W', 'LSTPHS', 'ANALIZING RESTRICTED DYNAMICS' )
      ENDIF
*
      RETURN
      END
