*-----------------------------------------------------------------------
*     BASIC ROUTINES
*-----------------------------------------------------------------------
*     MYPTMZ : PLOT TICKMARKS
*-----------------------------------------------------------------------
      SUBROUTINE MYPTMZ(UY,N,UPX,ROFFY,RTICK,INDEX)

      REAL      UY(*)


      IF (N.LE.0) THEN
        CALL MSGDMP('E','MYPTMZ','NUMBER OF POINTS IS INVALID.')
      END IF
      IF (INDEX.LE.0) THEN
        CALL MSGDMP('E','MYPTMZ','LINE INDEX IS INVALID.')
      END IF

      CALL SGQCLP(ICLIPZ)
      CALL SGSCLP(0)

      DO 10 I=1,N
        CALL SGNTRF(UPX,UY(I),VPX,VPY)
        CALL SGNTRF(UPX+RTICK,UY(I),VPXR,VPYR)
        FACT = ABS( RTICK ) / SQRT( (VPXR-VPX)**2 + (VPYR-VPY)**2 )
        VPXR = VPX + ( VPXR - VPX ) * FACT
        VPYR = VPY + ( VPYR - VPY ) * FACT
*
c$$$        VPX=VPX+ROFFY
        CALL SGLNZV(VPX,VPY,VPXR,VPYR,INDEX)
   10 CONTINUE

      CALL SGSCLP(ICLIPZ)

      END
