* PACKAGE ICORD !" ҥȥ꡼ ɸ
*
*"  [HIS] 92/09/17(takepiro)
*
***********************************************************************
      SUBROUTINE HQCORN    !" ɸ̾λ
     I         ( HCORD ,
     O           HALON , HALAT , HARAD ,
     O           KLEVS                   )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zhdim.F"                    !" ʸʸ
#endif
*
*   [INPUT] 
      CHARACTER  HCORD  *(*)                 !" ɸ
*
*   [OUTPUT] 
      CHARACTER  HALON  *(*)                 !" 1̾
      CHARACTER  HALAT  *(*)                 !" 2̾
      CHARACTER  HARAD  *(*)                 !" 3̾
*
*   [ENTRY INPUT] 
      REAL       ALON   ( * )                !" 1
      REAL       ALAT   ( * )                !" 2
      REAL       ARAD   ( * )                !" 3
      REAL       DLON   ( * )                !" 1
      REAL       DLAT   ( * )                !" 2
      REAL       DRAD   ( * )                !" 3
*
*   [INTERNAL SAVE] 
      CHARACTER  HALONZ *(NCC)               !" 1̾
      CHARACTER  HALATZ *(NCC)               !" 2̾
      CHARACTER  HARADZ *(NCC)               !" 3̾
      REAL       ALONZ  ( IMAX )             !" 1
      REAL       ALATZ  ( JMAX )             !" 2
      REAL       ARADZ  ( KMAX )             !" 3
      REAL       DLONZ  ( IMAX )             !" 1
      REAL       DLATZ  ( JMAX )             !" 2
      REAL       DRADZ  ( KMAX )             !" 3
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    KLEVS
*
      HALON  = HALONZ
      HALAT  = HALATZ
*
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         HARAD  = HARADZ
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         HARAD  = ' '
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORN', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HQCORL      !"  ɸ٥λ 
     I         ( HCORD ,
     O           KLEVS  )
*
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORL', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HQCORD      !"  ɸλ 
     I         ( HCORD ,
     O           DLON  , DLAT  , DRAD  ,
     O           KLEVS                   )
*
      CALL COPY ( DLON, DLONZ, IMAX )
      CALL COPY ( DLAT, DLATZ, JMAX )
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         CALL COPY ( DRAD, DRADZ,  KMAX )
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         DRAD( 1 ) = 1.0
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORD', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HQCORP      !"  ɸλ 
     I         ( HCORD ,
     O           ALON  , ALAT  , ARAD  ,
     O           KLEVS                   )
*
      CALL COPY ( ALON, ALONZ, IMAX )
      CALL COPY ( ALAT, ALATZ, JMAX )
      IF      ( HCORD .EQ. 'ALEV'  ) THEN
         CALL COPY ( ARAD, ARADZ,  KMAX )
         KLEVS  = KMAX
      ELSE IF ( HCORD .EQ. 'ASFC'  ) THEN
         ARAD( 1 ) = 1
         KLEVS  = 1
      ELSE
         CALL MSGDMP( 'W', 'HQCORP', 'UNKNOWN COORDINATE' )
      ENDIF
*
      RETURN
*=====================================================================
      ENTRY      HSCORD      !"  ɸϤ 
     I         ( HALON , HALAT , HARAD , 
     I           ALON  , ALAT  , ARAD  ,
     I           DLON  , DLAT  , DRAD    )
*
      HALONZ = HALON
      HALATZ = HALAT
      HARADZ = HARAD
*
      CALL COPY ( ALONZ , ALON  , IMAX   )
      CALL COPY ( ALATZ , ALAT  , JMAX   )
      CALL COPY ( ARADZ , ARAD  , KMAX   )
*
      CALL COPY ( DLONZ , DLON  , IMAX   )
      CALL COPY ( DLATZ , DLAT  , JMAX   )
      CALL COPY ( DRADZ , DRAD  , KMAX   )
*
      RETURN
*=====================================================================
      ENTRY      HSCORN      !"  ɸ̾ 
     I         ( HALON , HALAT , HARAD  )
*
      HALONZ = HALON
      HALATZ = HALAT
      HARADZ = HARAD
*
      RETURN
      END
